#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef JFB_WITH_LIBHANGUL
#include <stdio.h>
#include <stdlib.h>
#include <iconv.h>
#include <endian.h>
#include <string.h>
#include "hangul.h"
#include "conv.h"

int
conv_str(const char *fromenc, const char *toenc, unsigned char *fromstr, unsigned char *tostr)
{
	int inbytes, outbytes = CONV_SIZE;
	size_t ret;
	iconv_t cd;
	int flag = 0;
	unsigned char *tstr = NULL;

	cd = iconv_open(toenc, fromenc);
	if(cd == (iconv_t)-1) {
		return -1;
	}

	inbytes = strlen(fromstr);
	if(!strncmp(fromenc, "UCS-4", 5)) {
		ucschar *tmp;
		inbytes = 0;
		tmp = (unsigned int *)fromstr;
		while(*tmp != 0) {
			inbytes = inbytes + 4;
			tmp++;
		}
	}

	if(fromstr == tostr) {
		tstr = (unsigned char *)calloc(CONV_SIZE, sizeof(unsigned char));
		memcpy(tstr, tostr, CONV_SIZE);
		fromstr = tstr;
		flag = 1;
	}

	ret = iconv(cd, (char **)&fromstr, &inbytes, (char **)&tostr, &outbytes);
	if(flag == 1 && tstr != NULL) {
		free(tstr);
	}
	iconv_close(cd);
	if(ret == (size_t)-1) {
		return -1;
	}

	return CONV_SIZE - outbytes;
}
#endif /* JFB_WITH_LIBHANGUL */
